#include "stdafx.h"
#include <cassert>
#include <fstream>
#include <iostream>
#include <iostream>
#include <boost/smart_ptr.hpp>
#include <boost/algorithm/string.hpp>
#include "tinyxml2.h"
#include "M_ChannelSetCFG.h"
#include "FileEncrypt.h"
std::auto_ptr<M_ChannelSetCFG> M_ChannelSetCFG::msSingleton(nullptr);

int M_ChannelSetCFG::GetCount()
{
	return (int)mMapData.size();
}

const M_ChannelSetCFGData* M_ChannelSetCFG::GetData(std::string ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

boost::unordered_map<std::string, M_ChannelSetCFGData>& M_ChannelSetCFG::GetMapData()
{
	return mMapData;
}

void M_ChannelSetCFG::Reload()
{
	mMapData.clear();
	Load();
}

void M_ChannelSetCFG::Load(const std::string& path)
{
	std::ifstream readStream(path, std::ios::binary);
	if (!readStream.is_open())
	{
		assert(false);
		return;
	}
	readStream.seekg(0, std::ios::end);
	int fileSize = readStream.tellg();
	boost::shared_array<char> buffer(new char[fileSize+1]);
	buffer.get()[fileSize] = '\0';
	readStream.seekg(0, std::ios::beg);
	readStream.read(buffer.get(), fileSize);
	readStream.close();
	FileEncrypt::decryptBuffer( buffer, fileSize );
	tinyxml2::XMLDocument xmlDoc;
	auto result = xmlDoc.Parse(buffer.get(), fileSize);
	if (result != tinyxml2::XML_SUCCESS)
	{
		assert(false);
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		assert(false);
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_ChannelSetCFGData data;
		data.mID = element->Attribute("ID");
		data.mDesc = element->Attribute("Desc");
		data.mEnableFastLogin = element->BoolAttribute("EnableFastLogin");
		data.mEnableLocalLogin = element->BoolAttribute("EnableLocalLogin");
		data.mFishLvToOpen = element->IntAttribute("FishLvToOpen");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		assert(mMapData.find(data.mID) == mMapData.end());
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
}

void M_ChannelSetCFG::Load()
{
	Load("../Config/M_ChannelSetCFG.xml");
}

M_ChannelSetCFG* M_ChannelSetCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_ChannelSetCFG());
	}
	return msSingleton.get();
}
